############################################################
#
# $Id: test_type.py,v 1.1.1.1 2001/12/14 12:02:43 ahenja Exp $
#
# Description:	Example code for writing a self defined type
#		to an HDF5 file.
#
# Author(s):	Anders Henja
#
# Copyright:	Swedish Meteorological and Hydrological Institute, 2000
#
# History:	2000-03-22 Created by Anders Henja
############################################################
import _rave_info_type
import _pyhl

def test_write_type():
    rinfo_type=_rave_info_type.type()
    rinfo_obj=_rave_info_type.object()

    rinfo_obj.xsize=10
    rinfo_obj.ysize=10
    rinfo_obj.xscale=150.0
    rinfo_obj.yscale=150.0

    a=_pyhl.nodelist()
    b=_pyhl.node(_pyhl.GROUP_ID,"/info")
    a.addNode(b)

    b=_pyhl.node(_pyhl.TYPE_ID,"/MinDatatyp")
    b.commit(rinfo_type.hid())
    a.addNode(b)

    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/my_compound_attr")
    b.setScalarValue(rinfo_type.size(),rinfo_obj.tostring(),"compound",rinfo_type.hid())
    a.addNode(b)

    rinfo_obj.xsize=99
    rinfo_obj.ysize=109
    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/my_compound_attr2")
    b.setScalarValue(rinfo_type.size(),rinfo_obj.tostring(),"compound",rinfo_type.hid())
    a.addNode(b)

    b=_pyhl.node(_pyhl.DATASET_ID,"/my_dataset")
    b.setArrayValue(rinfo_type.size(),[1],rinfo_obj.tostring(),"compound",rinfo_type.hid())
    a.addNode(b)
    a.write("compound_file.hdf")

def test_read_type():
    rinfo_obj=_rave_info_type.object()
    a=_pyhl.read_nodelist("compound_file.hdf")
    a.selectAll()
    a.fetch()
    b=a.getNode("/my_compound_attr")
    rinfo_obj.fromstring(b.data())
    print "XSIZE="+`rinfo_obj.xsize`
    print "YSIZE="+`rinfo_obj.ysize`
    print "XSCALE="+`rinfo_obj.xscale`
    print "YSCALE="+`rinfo_obj.yscale`
    print "AREA EXTENT="+`rinfo_obj.area_extent`

if __name__=="__main__":
    test_write_type()
    test_read_type()
